<html lang="en">

	<head>
		<meta charset="utf-8">

		<title>The many methods of build an debian image</title>

		<meta name="description" content="Using LAVA for bisecting bugs">
		<meta name="author" content="Riku Voipio">

		<meta name="apple-mobile-web-app-capable" content="yes" />
		<meta name="apple-mobile-web-app-status-bar-style" content="black-translucent" />

		<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no, minimal-ui">

		<link rel="stylesheet" href="css/reveal.css">
		<link rel="stylesheet" href="css/theme/beige.css" id="theme">

		<!-- For syntax highlighting -->
		<link rel="stylesheet" href="lib/css/zenburn.css">

		<!-- If the query includes 'print-pdf', include the PDF print sheet -->
		<script>
				var link = document.createElement( 'link' );
                       link.rel = 'stylesheet';
                       link.type = 'text/css';
                       link.href = window.location.search.match( /print-pdf/gi ) ? 'css/print/pdf.css' : 'css/print/paper.css';
                       document.getElementsByTagName( 'head' )[0].appendChild( link );

		</script>
	</head>

	<body>

		<div class="reveal">

			<!-- Any section element inside of this container is displayed as a slide -->
			<div class="slides">
				<section>
					<h1>Building debian images</h1>
					<h3>- so many ways- </h3>
					<p>
					<img style="border:none" src="openlogo-nd.svg"/ ><br/><br/><br/><br/><br/><br/>
					<div align="right"><small>
						   By Riku Voipio - <a href="https://twitter.com/RikuVoipio">twitter.com/RikuVoipio</a> <a href="http://suihkulokki.blogspot.com">suihkulokki.blogspot.com</a></small></div>
					</p>
				</section>
				<section>
					<h2>What's a disk image</h2>
					<ul>
					<li>Disk images are files replicating contents of a hard drive or another storage media</li>
					<li>Bootable disk images can boot a computer after copying to a storage media</li>
					</ul>
					<img style="border:none;vertical-align:middle" width=200 height=200 src="hdd.svg"/> &rarr;
					<img style="border:none;vertical-align:middle" width=200 height=200 src="file.svg"/> &rarr;
					<img style="border:none;vertical-align:middle" width=200 height=200 src="hdd.svg"/> 
				</section>
				<section>
					<h2>my motivation</h2>
					<ul>
					    <li>At work we use <a href="https://wiki.linaro.org/Linaro-Image-Tools">linaro-media-create</a> (LMC)</li>
					    <li>It merges a generic distro rootfs with 
						    hardware specific bits “hwpack” to a SD card image</li>
					    <li>The idea was not distribute the images, but let people do it themself</li>
					    <li>Turns out users really like downloading premade images over running LMC</li>
                    	</ul>
				</section>
				<section>
					<h2>motivation #2</h2>
					<ul>
					    <li>LMC is not as good for us at used to be</li>
					    <li>The usecase is now a opposite of some of our goals:
						<li>“Single upstream kernel for a range of boards”</li>
						<li>LMC doesn't support new platforms (like <a href="http://96boards.org">96boards.org</a> ones)</li>
					     <li>We still use LMC but instead of developing it, we hack around it</li>
					     <li>Hence, I started looking for alternatives</li>
                    	</ul>
					<aside class="notes">There is now a "generic hwpack" In hopes that is useful for the general audience
					    Slides location <a href="people.linaro.org/~riku.voipio/debianimages">http://people.linaro.org/~riku.voipio/debianimages</a>
					</aside>
				</section>
				<section>
					<h2>Some findings</h2>
					<ul>
					     <li>Lots of Debian installs happened from images</li>
						<li class="fragment">Cloud/Hosted servers (<a href="https://wiki.debian.org/Cloud/AmazonEC2Image/Jessie">Amazon</a>, <a href="https://vmdepot.msopentech.com/Vhd/Show?vhdId=56730&version=58904">Azure</a>, <a href="https://github.com/scaleway/image-debian">Scaleway</a>, ...)  </li>
						<li class="fragment">Embedded systems (<a href="https://www.raspbian.org/RaspbianImages">rasperry pi</a>, <a href="http://beagleboard.org/latest-images">beaglebone</a>, <a href="http://download.solid-run.com/pub/solidrun/cubox-i/Debian/Jessi-repackaged-trial/">cubox</a>, ...) </li>
						<li class="fragment">OEM and workplace preinstalled machines using <a href="http://clonezilla.org">CloneZilla</a></li>
						<li class="fragment">And Live CD users who never install</li>
                    	</ul>
					<aside class="notes">How many people here are work with cloud servers / embedded? 
					</aside>
				</section>
				<section>
					<h2>Images vs installer</h2>
					<ul>
						<li>SPEED: D-I automated install 14min, cloud servers in seconds</li>
						<li>Convenience: “Just dd this file to a SD card” </li>
						<li>Easier to build an image than to add support to a strange platform to D-I</li>
                    </ul>
				</section>
				<section>
					<h2>What do image builders do</h2>
					<ol>
						<li class="fragment">Create partitions to a loopback file</li>
						<li class="fragment">Format filesystems</li>
						<li class="fragment">Run debootstrap</li>
						<li class="fragment">Install extra packages</li>
						<li class="fragment">Add users and set credentials</li>
						<li class="fragment">Do Hardcoded/Default customizations</li>
						<li class="fragment">Run user specified customizations</li>
						<li class="fragment">Install kernel</li>
						<li class="fragment">Install bootloader</li>
    		               </ol>
					<aside class="notes"> The list of things here might be look familiar
					</aside>
				</section>
				<section>
					<h2>Under hood</h2>
					<ul>
					    <li>losetup</a>: loopback mount</li>
					    <li><a href="https://packages.debian.org/sid/parted">parted</a>: partitioning  tool</li>
					    <li><a href="https://packages.debian.org/sid/debootstrap">debootstrap</a>: installs basic debian</li>
					    <li><a href="https://packages.debian.org/sid/kpartx">kpartx</a>: automated loopback partition mounting</li>
					    <li><a href="https://packages.debian.org/sid/qemu">qemu</a>: disk image format conversion and cross-arch emulation</li>
					    <li><a href="https://packages.debian.org/sid/cloud-init">cloud-init</a>: “firstboot preseed” - cloud image personalization</li>
					</ul>
					<aside class="notes">Also possible to use fdisk, mkfs etc
					</aside>
				</section>
	               <section>
					<h2>Image builder tour</h2>
					<p>Because there is no official way, everyone writes their own image build tool</p>
				</section>
				<section>
					<h2>“everyone should use D-I”</h2>
					<p>Debian Installer is the official™ way to install Debian.
                    </p>
				</section>
				<section>
					<h2>Debian Installer</h2>
					<ul>
					     <li>YES WE CAN create images with D-I</li>
					     <li>Either manually or automated with preseeding</li>
					     <li>Drawback: Installed with booting - virtualization to rescue</li>
						<li>Images are customized with a <a href="preseed.cfg">preseed file</a></li>
						<li>Easy tool for virtualized install is <a href="https://packages.debian.org/sid/virtinst">virt-inst</a></li>
					</ul>
				</section>
				<section>
					<h2>Debian-Installer example</h2>
					<pre><code>apt install virtinst libvirt-bin
virsh net-start
sudo virt-install --connect qemu:///system --name Debian8 --ram 1024 \
 --file debian.img --file-size=8 --initrd-inject=preseed.cfg \
 --virt-type kvm --os-variant debianwheezy --extra-args="auto" \
 --location http://http.debian.net/debian/dists/stable/main/installer-amd64/
					</code></pre>
				</section>
				<section>
					<h2>Debian-Installer limitations</h2>
					<ul>
						<li>Platform needs to be supported by D-I</li>
						<li>When preseeding is not enough, a custom D-I is needed</li>
						<li>Barrier to customize D-I can be daunting</li>
						<li>Doesn't anonymize image - shared ssh host keys etc</li>
						<li>Image generation took 14Min</li>
					</ul>
				</section>
				<section>
					<h2>live-build</h2>
					<ul>
						<li>The tool used to build <a href="https://www.debian.org/CD/live/">Official Debian Live CD's</a></li>
						<li>Uses chroot, and supports cross-arch installs with Qemu</li>
						<li>Targets <a href="http://live.debian.net/manual/3.x/html/live-manual/customizing-run-time-behaviours.en.html#529">read-only</a> images primarily</li>
						<li>Customized with <a href="http://live.debian.net/manual/4.x/html/live-manual/customizing-contents.en.html">hook scripts</a></li>
						<li>Hooks take care of anonymizing ssh host keys etc</li>
					</ul>
				</section>
				<section>
					<h2>live-build example</h2>
					<pre><code>apt install live-build
lb config -b hdd --linux-packages linux-image-4.0-custom -m http://http.debian.net/debian
echo task-kde-desktop &gt;&gt; config/package-lists/my.list.chroot 
sudo lb build</code></pre>
				</section>
				<section>
					<h2>bootstrap-vz</h2>
					<ul>
					<li>Packaged in <a href="">Debian</a> but the one used is in <a href="https://github.com/andsens/bootstrap-vz">github</a></li>
					<li>Builds the most <b>official</b> Debian images for <a href="https://github.com/andsens/bootstrap-vz/tree/master/bootstrapvz/providers">Amazon, Google</a>, and other cloud providers</li>
					<li>Written in python, extendable via plugins and has <b>tests</b></li>
					<pre><code>sudo apt install bootstrap-vz
git clone https://github.com/andsens/bootstrap-vz.git
./bootstrap-vz ./manifests/examples/kvm/wheezy-virtio.yml</code></pre>
					</ul>
				</section>
				<section>
					<h2>bootstrap-vz configuration</h2>
					<pre><code>provider:
  name: gce
bootstrapper:
  workspace: /target
image:
  name: disk
  description: Debian {system.release} {system.architecture}
system:
  release: jessie
  architecture: amd64
  bootloader: grub
  charmap: UTF-8
  locale: en_US
  timezone: UTC
volume:
  backing: raw
  partitions:
    type: msdos
    root:
      filesystem: ext4
      size: 10GiB
packages:
  mirror: http://gce_debian_mirror.storage.googleapis.com/
  components:
  - main
  - contrib
  - non-free
plugins:
  google_cloud_sdk: {}
  ntp:
    servers:
    - metadata.google.internal</pre></code>
				</section>
				<section>
					<h2>vmdebootstrap</h2>
					<ul>
					<li>debootstrap wrapper for disk image building</li>
					<li>Explicit cross-arch support with --foreign option</li>
					<li>No configuration file, just command line</li>
					<li>DYI customization scripts</li>
					</ul>
				</section>
				<section>
					<h2>vmdebootstrap example</h2>
					<pre><code>sudo vmdebootstrap \
 --owner $(whoami) --verbose \
 --mirror http://httpredir.debian.org/debian \
 --arch armhf \
 --foreign /usr/bin/qemu-arm-static \
 --enable-dhcp \
 --configure-apt \
 --no-extlinux \
 --no-kernel \
 --root-password=rootme \
 --package u-boot \
 --package linux-image-armmp \
 --distribution sid \
 --serial-console-command "'/sbin/getty -L ttyO0 115200 vt100'" \
 --customize "beagleboneblack-customise.sh" \
 --bootsize 50m --boottype vfat \
 --image bbb.img</code></pre>
				</section>
				<section>
					<h2>For Openstack</h2>
					<ul>
						<li>OpenStack team maintains two tools for building bootable images</li>
						<li><a href="https://packages.debian.org/sid/openstack-debian-images">openstack-debian-images</a>: Pure debian images</li>
						<li><a href="https://packages.debian.org/sid/python-diskimage-builder">diskimage-builder</a>: Build disk images of many distributions</li>
					</ul>
				</section>
				<section>
					<h2>More image builders in Debian archive</h2>
					<ul>
					    <li class="fragment"><a  href="https://packages.debian.org/sid/xen-tools">Xen-tools</a>: Build debian and other distro Xen< guests </li>
					    <li class="fragment"><a  href="https://packages.debian.org/sid/rootstrap">rootstrap</a>: Originally for UML but makes generic images</li>
					    <li class="fragment"><a  href="https://packages.debian.org/sid/linaro-image-tools">linaro-media-create</a>: Combines a rootfs with kernel/bootloader to a bootable image</li>
					    <li class="fragment"><a  href="https://packages.debian.org/sid/grml-debootstrap">grml-debootstrap</a>: <a href="https://grml.org">GRML</a> projects images creation tool</li>
					    <li class="fragment">10 tools so far, did I miss any in Debian?</li>
					</ul>
				</section>
				<section>
					<h2>Even more image builders outside...</h2>
					<ul>
					    <li class="fragment"><a href="https://github.com/RPi-Distro/spindle">spindle</a>: with <a href="https://www.raspberrypi.org/blog/five-million-sold/">5+ million</a> users can't be wrong</li> 
					    <li class="fragment"><a href="https://github.com/RobertCNelson/omap-image-builder">omap-image-builder</a>: Creates OEM images for BeagleBone black and similar</li> 
					    <li class="fragment"><a href="https://github.com/igorpecovnik/lib">armbian</a>: Builds images for cubox/hummingboard</li> 
					    <li class="fragment"><a href="http://kameleon.imag.fr/">Kameleon</a>: Appliance creator, used at least at <a href="https://www.grid5000.fr/mediawiki/index.php/Grid5000:Home">Grid 5000</a></li>
					    <li class="fragment"><a href="https://launchpad.net/vmbuilder">VMbuilder</a>: a deprecated virtual machine image builder</li>
					    <li class="fragment">Ubuntu <a href="https://code.launchpad.net/~ubuntu-on-ec2/vmbuilder/automated-ec2-builds">automated EC2 builds</a>: builds their official <a href="https://cloud-images.ubuntu.com/">Cloud images</a></li>
					    <li class="fragment">Many many more..</li>
					</ul>
				</section>
				<section>
				    <section>
				    <h2>How are they done</h2>
				    <table>
					   <tr><th>tool</th><th>language</th></tr>
					   <tr><td>debian-installer</td><td>shell, C</td></tr>
					   <tr><td>live-build</td><td>shell</td></tr>
					   <tr><td>bootstrap-vz</td><td>python</td></tr>
					   <tr><td>vmdebootstrap</td><td>python, shell</td></tr>
					   <tr><td>xen-tools</td><td>perl</td></tr>
					   <tr><td>rootstrap</td><td>shell</td></tr>
				    </table>
				    </section>
				    <section>
				    <table>
					   <tr><td>linaro-image-tools</td><td>python</td></tr>
					   <tr><td>grml-debootstrap</td><td>shell</td></tr>
					   <tr><td>openstack-debian-images</td><td>shell</td></tr>
					   <tr><td>diskimage-builder</td><td>shell, python</td></tr>
					   <tr><td>spindle</td><td>shell</td></tr>
					   <tr><td>omap-image-builder</td><td>shell</td></tr>
					   <tr><td>armbian</td><td>shell</td></tr>
				    </table>
				    </section>

				</section>
				<section>
					<h2>subjective conclusion</h2>
					<img src="bikeshed.jpg" />
				</section>
				<section>
					<h2>subjective conclusions #2</h2>
					<ul>
						<li>For many tools, main developer = main user</li>
						<li>Each tool is tailored for the developers usecase and personal taste</li>
						<li>Any tool that wants come more widely used needs to be really nice to use</li>
					</ul>
				</section>
				<section>
					<h2>Shortcomings in the tools</h2>
					<ul>
						<li class="fragment">Hackable user setup: default passwords!</li>
						<li class="fragment">Use-case specific hardcoded customizations</li>
						<li class="fragment">Hardcoded/restricted partitiong</li>
						<li class="fragment">Missing first-boot customizations</li>
						<li class="fragment">Unupgradeable kernel, bootloader</li>
						<li class="fragment">Copying bits from the host system</li>
						<li class="fragment">Cool features only in some tools</li>
						<li class="fragment">Example: automatically grow rootfs size to media size on first boot</li>
						<li class="fragment">Underdocumentation - how to add an new bootloader etc</li>
    		               </ul>
				</section>
				<section>
					<h2>Can we fix it?</h2>
					<p class=fragment>systemd-image-creator</p>
					<p class=fragment>
					<img src="stefano.jpg"/><br>
					Just kidding!</p>
				</section>
				<section>
					<h2>Suggestions for discussions</h2>
					<ul>
						<li>Release official Debian images in line with installers</li>
						<li>Provide link to tool / command line / config used to build the image</li>
						<li>packages for things like first-boot customization</li>
						<li>Customizations should in general be packages, not part of the image creating tool</li>
						<li>Any other key requirements?</li>
					<aside class="notes">Link to script that creates images
					</aside>
                    	</ul>
				</section>
				<section>
					<h2>Time for discussions</h2>
				</section>

			</div>
		</div>

		<script src="lib/js/head.min.js"></script>
		<script src="js/reveal.js"></script>

		<script>

			// Full list of configuration options available here:
			// https://github.com/hakimel/reveal.js#configuration
			Reveal.initialize({
				controls: true,
				progress: true,
				history: true,
				center: true,
				transition: 'convex', // none/fade/slide/convex/concave/zoom


				dependencies: [
					{ src: 'lib/js/classList.js', condition: function() { return !document.body.classList; } },
					{ src: 'plugin/markdown/marked.js', condition: function() { return !!document.querySelector( '[data-markdown]' ); } },
					{ src: 'plugin/markdown/markdown.js', condition: function() { return !!document.querySelector( '[data-markdown]' ); } },
					{ src: 'plugin/highlight/highlight.js', async: true, condition: function() { return !!document.querySelector( 'pre code' ); }, callback: function() { hljs.initHighlightingOnLoad(); } },
					{ src: 'plugin/zoom-js/zoom.js', async: true },
                         { src: 'plugin/notes/notes.js', async: true }
				]
			});

		</script>

	</body>
</html>
